require 'sketchup'

def import_cam
	cam_file = UI.openpanel "Open cam File", "", ""
	
	f_in = open(cam_file)
	gruops = Array.new()
	g_index = 0
	
	
	#group.entities.add_line([0,0,0],[100,100,100])
	
	#model = Sketchup.active_model
	#entities = model.active_entities
	
	pts = Array.new()
	pt_index = 0
	while line = f_in.gets
		#	X006037Y000141D02*
		if /^X(\d{2})(\d{4})Y(\d{2})(\d{4})D(\d{2})\*$/ =~ line then
			if $5 == "02" then
				if pts.size > 0 then
					#if pts[0].eql?(pts.last) then
						#model.entities.add_face pts
					#else
						#model.entities.add_edges pts
					#end
					gruops[g_index] = Sketchup.active_model.entities.add_group
					gruops[g_index].entities.add_edges pts
					g_index += 1
					pts.clear
					pt_index = 0
				end
			end
		
			xNum = ($1 + "." + $2).to_f
			yNum = ($3 + "." + $4).to_f
			pts[pt_index] = [xNum, yNum, 0.0]
			pt_index += 1
		end
	end
	gruops[g_index] = Sketchup.active_model.entities.add_group
	gruops[g_index].entities.add_edges pts
end		#def import_cam

UI.menu("PlugIns").add_item("Import CAM file") { import_cam }